﻿using System;

namespace DemoRect
{
    class Program
    {
        static void Main(string[] args)
        {
            Console.WriteLine("Hello World!");
            GrapeCity.Documents.Pdf.GcPdfDocument Document1 = new GrapeCity.Documents.Pdf.GcPdfDocument();
            TextLayoutOutsideRectangle obj = new TextLayoutOutsideRectangle(Document1);
            obj.ShowIssue(Document1);
            Console.WriteLine("Hello World!");

        }
    }
 
    public class TextLayoutOutsideRectangle
    {​​​​​​​
        public const float Resolution = 72f;
        public const float Point = 1f;
        public const float Inch = Point * Resolution;
        public const float CM = Inch / 2.54f;
        public const float MM = CM / 10;


        GrapeCity.Documents.Pdf.GcPdfDocument Document;
        GrapeCity.Documents.Text.TextFormat TextFormat1;
        GrapeCity.Documents.Pdf.GcPdfGraphics Graphics;
        GrapeCity.Documents.Pdf.Page Page;
        System.Drawing.SizeF PageSize;
        System.Drawing.RectangleF TextRect;


        public void ShowIssue(Object doc)
        {​​​​​​​
            new TextLayoutOutsideRectangle((GrapeCity.Documents.Pdf.GcPdfDocument)doc).DrawPages();
        }​​​​​​​
 
       public TextLayoutOutsideRectangle(GrapeCity.Documents.Pdf.GcPdfDocument doc)
        {​​​​​​​
            Document = doc;
            TextFormat1 = new GrapeCity.Documents.Text.TextFormat()
            {​​​​​​​
                Font = GrapeCity.Documents.Text.FontCollection.SystemFonts.FindFamilyName("Segoe UI", false, true),
                FontSize = 48,
                ForeColor = System.Drawing.Color.Black,
                UseTypoMetrics = true, // cross platform independent
                EnableFontHinting = true, // is default true
                FontSizeInGraphicUnits = false, // typographic units
            }​​​​​​​;
        }​​​​​​​


        void AddPage()
        {​​​​​​​
            Page = Document.NewPage();
            Page.PaperKind = GrapeCity.Documents.Common.PaperKind.A4;
            Page.Landscape = false;
            PageSize = Page.GetRenderSize(Resolution, Resolution);
            Graphics = Page.Graphics;
            Graphics.Resolution = Resolution;
            TextRect = new System.Drawing.RectangleF(0, 0, PageSize.Width, PageSize.Height);
            TextRect.Inflate(-2.5f * CM, -2.7f * CM);
            Graphics.DrawRectangle(TextRect, new GrapeCity.Documents.Drawing.Pen(System.Drawing.Color.Red, 2f * MM));
        }​​​​​​​


        void DrawPage(bool useObjectRect)
        {​​​​​​​
            AddPage();


            // create TextLayout
            var rect = TextRect;
            GrapeCity.Documents.Text.TextLayout text2 = null;
            var text = new GrapeCity.Documents.Text.TextLayout(Graphics.Resolution)
            {​​​​​​​
                MarginLeft = rect.X,
                MarginTop = rect.Y,
                MarginRight = 0,
                MarginBottom = 0,
                MaxWidth = rect.Right,
                MaxHeight = rect.Bottom,
                ParagraphAlignment = GrapeCity.Documents.Text.ParagraphAlignment.Near,
                TextAlignment = GrapeCity.Documents.Text.TextAlignment.Leading,
                //AlignmentDelayToSplit = useSplit,
                //LastLineIsEndOfParagraph = true,
                //HonorLastLineSpacing = true,
                //AllowOverhangingWords = true,
                TrimmingGranularity = GrapeCity.Documents.Text.TrimmingGranularity.Word,
                EllipsisCharCode = '.',
                WrapMode = GrapeCity.Documents.Text.WrapMode.WordWrap,
                //SoftHyphenReplacementCharCode = 0x2D,
            }​​​​​​​;
            string lorem = "Lorem ip\xADsum dolor sit amet, consectetur adipiscing elit. Inte\xADger so\u00ADdales iaculis dic\xADtum. Nam in porta dolor. Pel\xADlentesque neque orci, maximus in accumsan eget, tin\x00ADcidunt nec eros. Aenean vitae nisi vel purus maximus di\x00ADgnis\xADsim. Proin sag\xADit\xADtis elementum pharetra. Mauris eu tellus pretium, luctus dui eget, pharetra velit. Nunc fermentum tortor ante, eget sodales sapien imperdiet ut.";
            text.Append(string.Format("Page: {​​​​​​​0}​​​​​​​, ObjectRect: {​​​​​​​1}​​​​​​​.\n", Page.Index + 1, useObjectRect) + lorem, TextFormat1);
            text.RecalculateGlyphs();


            // Add Optional ObjectRectangles
            if (useObjectRect)
            {​​​​​​​
                // add object list. But without objects. It should have no effect.
                text.ObjectRects = new System.Collections.Generic.List<GrapeCity.Documents.Text.ObjectRect>();
            }​​​​​​​
            // Perform Layout
            text.PerformLayout(false);
            // Split if requested
            if (!text.ContentWidthFitsInBounds || !text.ContentHeightFitsInBounds)
            {​​​​​​​
                var textSplitOptions = new GrapeCity.Documents.Text.TextSplitOptions()
                {​​​​​​​
                    AddSpacingAfterLastLine = false,
                    KeepParagraphLinesTogether = false,
                    LineGapBeforeFirstLine = false,
                    MinLinesInFirstParagraph = 1,
                    MinLinesInLastParagraph = 1,
                    RestMarginLeft = rect.X,
                    RestMarginTop = rect.Y,
                    RestMarginRight = 0,
                    RestMarginBottom = 0,
                    RestMaxWidth = rect.Right,
                    RestMaxHeight = rect.Bottom,
                }​​​​​​​;
                if (useObjectRect)
                {​​​​​​​
                    // add object list. But without objects. It should have no effect.
                    textSplitOptions.RestObjectRects = new System.Collections.Generic.List<GrapeCity.Documents.Text.ObjectRect>();
                }​​​​​​​
                text.Split(textSplitOptions, out text2);
                text.PerformLayout(false);
            }​​​​​​​


            // Draw TextLayout
            Graphics.DrawTextLayout(text, System.Drawing.PointF.Empty);


            //  Draw Rectangle of the resulting ContentRectangle
            Graphics.DrawRectangle(text.ContentRectangle, new GrapeCity.Documents.Drawing.Pen(System.Drawing.Color.LightGreen, 1f * MM));


            // should we draw the next page?
            if (text2 != null)
            {​​​​​​​
                AddPage();
                text2.ParagraphAlignment = GrapeCity.Documents.Text.ParagraphAlignment.Near;
                text2.TextAlignment = GrapeCity.Documents.Text.TextAlignment.Leading;
                text2.PerformLayout(false);
                Graphics.DrawTextLayout(text2, System.Drawing.PointF.Empty);
                //  Draw Rectangle of the resulting ContentRectangle
                Graphics.DrawRectangle(text2.ContentRectangle, new GrapeCity.Documents.Drawing.Pen(System.Drawing.Color.DarkOliveGreen, 1f * MM));
            }​​​​​​​
        }​​​​​​​


        void DrawPages()
        {​​​​​​​
            // Page 1: no Object Rectangles: ALL OK.
            DrawPage(false);
            // Page 3: Object Rectangles: Content Rectangle uses the whole Layout (WRONG).
            DrawPage(true);
            Document.Save("Demo.docx");
        }​​​​​​​
    }​​​​​​​
}
